org.apache.felix.bundlerepository

## Interface DataModelHelper

All Known Implementing Classes:
  DataModelHelperImpl

    public interface DataModelHelper

### Method Summary

Methods
`Capability` `capability(java.lang.String name, java.util.Map properties)` Create a capability
`Resource` `createResource(java.util.jar.Attributes attributes)` Create a resource corresponding to the given manifest entries.
`Resource` `createResource(org.osgi.framework.Bundle bundle)` Create a resource corresponding to the given bundle.
`Resource` `createResource(java.net.URL bundleUrl)` Create a resource for the bundle located at the given location.
`org.osgi.framework.Filter` `filter(java.lang.String filter)` Create an extender filter supporting the SUBSET, SUPERSET and other extensions
`Capability` `readCapability(java.io.Reader reader)`
`Capability` `readCapability(java.lang.String xml)`
`Property` `readProperty(java.io.Reader reader)`
`Property` `readProperty(java.lang.String xml)`
`Repository` `readRepository(java.io.Reader reader)`
`Repository` `readRepository(java.lang.String xml)`
`Requirement` `readRequirement(java.io.Reader reader)`
`Requirement` `readRequirement(java.lang.String xml)`
`Resource` `readResource(java.io.Reader reader)`
`Resource` `readResource(java.lang.String xml)`
`Repository` `repository(Resource[] resources)` Create a repository for the given set of resources.
`Repository` `repository(java.net.URL repository)` Create a repository from the specified URL.
`Requirement` `requirement(java.lang.String name, java.lang.String filter)` Create a simple requirement to be used for selection
`java.lang.String` `writeCapability(Capability capability)`
`void` `writeCapability(Capability capability, java.io.Writer writer)`
`java.lang.String` `writeProperty(Property property)`
`void` `writeProperty(Property property, java.io.Writer writer)`
`java.lang.String` `writeRepository(Repository repository)`
`void` `writeRepository(Repository repository, java.io.Writer writer)`
`java.lang.String` `writeRequirement(Requirement requirement)`
`void` `writeRequirement(Requirement requirement, java.io.Writer writer)`
`java.lang.String` `writeResource(Resource resource)`
`void` `writeResource(Resource resource, java.io.Writer writer)`

### Method Detail

#### requirement

    Requirement requirement(java.lang.String name,
                          java.lang.String filter)

Create a simple requirement to be used for selection

Parameters:
  `name` -
  `filter` -
Returns:
Throws:
  `org.osgi.framework.InvalidSyntaxException`

#### filter

    org.osgi.framework.Filter filter(java.lang.String filter)
                                     throws org.osgi.framework.InvalidSyntaxException

Create an extender filter supporting the SUBSET, SUPERSET and other extensions

Parameters:
  `filter` - the string filter
Returns:
Throws:
  `org.osgi.framework.InvalidSyntaxException`

#### repository

    Repository repository(java.net.URL repository)
                          throws java.lang.Exception

Create a repository from the specified URL.

Parameters:
  `repository` -
Returns:
Throws:
  `java.lang.Exception`

#### repository

    Repository repository(Resource[] resources)

Create a repository for the given set of resources. Such repositories can be used to create a resolver that would resolve on a subset of available resources instead of all of them.

Parameters:
  `resources` - an array of resources
Returns:
  a repository containing the given resources

#### capability

    Capability capability(java.lang.String name,
                        java.util.Map properties)

Create a capability

Parameters:
  `name` - name of this capability
  `properties` - the properties
Returns:
  a new capability with the specified name and properties

#### createResource

    Resource createResource(org.osgi.framework.Bundle bundle)

Create a resource corresponding to the given bundle.

Parameters:
  `bundle` - the bundle
Returns:
  the corresponding resource

#### createResource

    Resource createResource(java.net.URL bundleUrl)
                            throws java.io.IOException

Create a resource for the bundle located at the given location.

Parameters:
  `bundleUrl` - the location of the bundle
Returns:
  the corresponding resource
Throws:
  `java.io.IOException`

#### createResource

    Resource createResource(java.util.jar.Attributes attributes)

Create a resource corresponding to the given manifest entries.

Parameters:
  `attributes` - the manifest headers
Returns:
  the corresponding resource

#### readRepository

    Repository readRepository(java.lang.String xml)
                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readRepository

    Repository readRepository(java.io.Reader reader)
                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readResource

    Resource readResource(java.lang.String xml)
                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readResource

    Resource readResource(java.io.Reader reader)
                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readCapability

    Capability readCapability(java.lang.String xml)
                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readCapability

    Capability readCapability(java.io.Reader reader)
                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readRequirement

    Requirement readRequirement(java.lang.String xml)
                                throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readRequirement

    Requirement readRequirement(java.io.Reader reader)
                                throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readProperty

    Property readProperty(java.lang.String xml)
                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### readProperty

    Property readProperty(java.io.Reader reader)
                          throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### writeRepository

    java.lang.String writeRepository(Repository repository)

#### writeRepository

    void writeRepository(Repository repository,
                       java.io.Writer writer)
                         throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeResource

    java.lang.String writeResource(Resource resource)

#### writeResource

    void writeResource(Resource resource,
                     java.io.Writer writer)
                       throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeCapability

    java.lang.String writeCapability(Capability capability)

#### writeCapability

    void writeCapability(Capability capability,
                       java.io.Writer writer)
                         throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeRequirement

    java.lang.String writeRequirement(Requirement requirement)

#### writeRequirement

    void writeRequirement(Requirement requirement,
                        java.io.Writer writer)
                          throws java.io.IOException

Throws:
  `java.io.IOException`

#### writeProperty

    java.lang.String writeProperty(Property property)

#### writeProperty

    void writeProperty(Property property,
                     java.io.Writer writer)
                       throws java.io.IOException

Throws:
  `java.io.IOException`